#include "QBaseTree.hh"
#include "QTreeInfo.hh"
#include <TList.h>
#include <TBuffer.h>
#include <iostream>

ClassImp(QBaseTree);

QBaseTree::QBaseTree() {
   
}


QBaseTree::QBaseTree(QTreeType type, const char* title): TTree(QTREE_NAME, title, 99) {
    
    if(type == QTREE) GetTreeInfo().fType = 0;
    else if(type == QATREE) GetTreeInfo().fType = 1;
    else if(type == QITREE) GetTreeInfo().fType = 2;
}


QTreeInfo& QBaseTree::GetTreeInfo()
{
    TObject* obj = GetUserInfo()->FindObject("QTreeInfo");
    if(!obj) {
        obj = new QTreeInfo;
        GetUserInfo()->AddLast(obj);
    }
    QTreeInfo* sobj = dynamic_cast<QTreeInfo*>(obj);
    if(!sobj) std::cout<<"Error: object with name QTreeInfo is not of type QTreeInfo"<<std::endl;
    return *sobj;

}

void QBaseTree::Streamer(TBuffer &R__b) 
{ 

    if (R__b.IsReading()) {    
        UInt_t R__s, R__c; 
        Version_t R__v = R__b.ReadVersion(&R__s, &R__c); 
        if(R__v < 2) {
            TTree::Streamer(R__b);
            Int_t t;
            R__b>>t;
            if(t == 0) GetTreeInfo().fType = QTREE;
            else if(t == 1) GetTreeInfo().fType = QATREE;
            else if(t == 2) GetTreeInfo().fType = QITREE;
        } else {
            R__b.ReadClassBuffer(QBaseTree::Class(), this, R__v, R__s, R__c);

        }
    } else { 
        QBaseTree::Class()->WriteBuffer(R__b, this);   
    } 
}  
