#ifndef _Q_BASETREE_HH_
#define _Q_BASETREE_HH_
/**
 * @file QBaseTree.hh
 * @class QBaseTree
 * @brief abstract class for diana trees
 *
 * @author Marco Vignati
 *
 * This class implements additional functions to TTree.
 * So far it imlements the Get/SetVersion() methods to retreive the
 * sw version when the tree was written.
 *
 * It also provides backward compatibility with the old diana trees.
 *
 */

#define QTREE_NAME "qtree" /** tree name */

#include <TTree.h>
#include "Rtypes.h"
#include "QTreeInfo.hh"

class QBaseEventR;

class QBaseTree : public TTree 
{
	public:
		enum QTreeType {
			QTREE,
			QATREE,
			QITREE
		};

		QBaseTree();

		QBaseTree(QTreeType, const char* title);

		virtual ~QBaseTree() {}

        QTreeInfo& GetTreeInfo();

        const std::string& GetSoftwareRevision() { return GetTreeInfo().fSoftwareRevision; }

        const std::string& GetVersionTag() { return GetTreeInfo().fVersionTag; }


	protected:

		ClassDef(QBaseTree,3);
};


#endif
